<?php

/*
PHP Photo Album
Version 2.2
Created by Jeff Harrell
http://www.juxtadesign.com

Just place the PHP file into a directory that contains subdirectories full of
images. For instance, I have the PHP script in a directory called "rolls" and
in that directory I have subdirectories of "europe_2003", "christmas_2003", etc.

albums
   |__ index.php
   |__ /europe_2003/
   |__ /christmas_2003/
   |__ /etc.../
  
The script will act as a browser of these directories and will use the
directory and image names as titles.  For formatting, the "_" character
will be converted to a space.   

Make sure there are no image files on the same level as the PHP script. Any nesting
of images and directories on the same level will cause the directories to be ignored.

You may also add a description to the image by including a .txt file with the same name
as the image (minus the image extension, i.e. JPG) in the same directory.

Feel free to implement this however you want. However, if you make any good
changes then let me know and I will see about incorporating them.


CHANGELOG

2.2 Added the ability to include text file desriptions to the image
    Added image counts to the directory listing
    Directories are not marked as new if they are

2.1 Minor improvements and updated the style sheet.

2.0 Public release.

1.0 Private release for my personal website only.

*/



/* CONFIGURABLE OPTIONS */

// html that will appear in the header div of the page
//$header  = '<a onclick="if(window.opener) { window.opener.location = this.href; window.close(); return false}" href="http://www.juxtadesign.com/photos/index.php" title="Juxta Design | Photos by Jeff Harrell">';
//$header .= '<img src="http://www.juxtadesign.com/images/juxtalogo.png" width="173" height="22" alt="Juxta Design"/>';
//$header .= '</a>';
$header = '';

// the CSS is located in an external file named in the configuration below.
// if you would like to use the style sheet this was created with you may
// download it here:
// http://photos.juxtadesign.com/
$style_sheet = 'includes/styles.css';

// allowed image extensions (separated by spaces)
$image_extensions = 'jpg gif';

// 
$written_description_file = '__written.txt';

// 
$yes_file = '__yes.txt';

// directories to ignore (separated by spaces)
$ignore_folders = 'includes';

// number of days a directory is marked as new
// set to 0 to disable
$new_days = 7;




/* NO NEED TO CHANGE BELOW UNLESS YOU WANT TO */

// get the scripts info
$show_directory = $_GET['directory'];
$show_image = $_GET['image'];
$show_mode = $_GET['mode'];
$show_title = $_POST['title'];
$show_date = $_POST['date'];
$show_client  = $_POST['client'];
$show_caregiver  = $_POST['caregiver'];
$show_activity = $_POST['activity'];
$show_desc = $_POST['desc'];
$show_mood  = $_POST['mood'];
$show_question  = $_POST['question'];
$show_print = $_GET['print'];
$show_ans = $_POST['ans'];
$upload_fname = basename($_FILES['userfile']['name']);
$upload_tmp = $_FILES['userfile']['tmp_name'];
$show_delete = $_GET['delete'];
$show_newalbum = $_POST['newalbum'];
$show_command = $_GET['command'];

if ($show_mode == null || $show_mode =='')
	$show_mode = $_POST['mode'];
if ($show_directory == null || $show_directory =='' )
	$show_directory = $_POST['directory'];
if ($show_image == null || $show_image =='' )
	$show_image = $_POST['image'];
if ($show_ans == null || $show_ans =='' )
	$show_ans = $_GET['ans'];

$save_written_condition = ($show_title != null || $show_date != null || $show_client != null || $show_caregiver != null || $show_activity != null || $show_description != null || $show_mood != null || $show_question != null);



// Date in the past
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

// always modified
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
 
// HTTP/1.1
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);

// HTTP/1.0
header("Pragma: no-cache");


function process_photos() {
    global $show_directory, $show_image, $image_extensions, $ignore_folders, $upload_tmp, $upload_fname, $show_delete, $show_newalbum;

    // if url contains a directory go there
    if (isset($show_directory) AND $show_directory != '') {
        if (is_dir($show_directory)) {
            chdir($show_directory);
        } else {
            // error directory does not exist!
            header('Location: ' . $_SERVER['SCRIPT_NAME']);
        }
    }
    
    // now get the current directory
    $cwd = getcwd();

    // convert ignored files to an array
    $bad_dirs = explode(' ', $ignore_folders);

    // convert good extensions to an array
    $good_ext = explode(' ', $image_extensions);

    // process upload	        
    $upload_ext = explode('.', $upload_fname);
    $upload_ext = $upload_ext[count($upload_ext) -1];
    if (in_array($upload_ext, $good_ext)){
	    move_uploaded_file($upload_tmp, $cwd . '/' . $upload_fname);
    }

    // process new album creation
    if ($show_newalbum != null && $show_newalbum != ''){
	//if no existing folder with the same name, try to create
	if(!file_exists($show_newalbum))
		mkdir($show_newalbum);
    }

    // open directory
    if ($handle = opendir($cwd)) {
        // loop through all files adding files and directories to an array
        while (false !== ($file = readdir($handle))) {
            if (!preg_match("/^\./", $file)) {
                // get this files extension
                $this_ext = explode('.', $file);
                $this_ext = $this_ext[count($this_ext) - 1];
                
                // check each file / directory for inclusion
                if (is_dir($file) AND !in_array($file, $bad_dirs)) {
                    $dirs[$file] = $file;
                } else if (in_array($this_ext, $good_ext)) {
                    $files[] = $file;
                }
            }
        }
    
        // close directory
        closedir($handle);

	// process delete
	if ($show_delete != null && $show_delete != ''){
		if(is_file($files[$show_delete])){
			unlink($files[$show_delete]);
			save_ans("no", $files[$show_delete]);
			echo '<p style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Photo deleted.</p>';
			echo '<p style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"><a class="index" href="index.php?directory=';
			echo $show_directory;
			echo '&amp;mode=photos">Back</a></p>';
		} else {
			echo '<p> Photo not deleted.</p>';
		}
	} else {
	      // if there are no files then look for folders
	      // otherwise show the images
	      if (!processfiles($files, $dirs, $cwd)) {
		  processfolders($dirs);        
	      }
        }
    }

    return ob_get_contents();
}


function process_written() {
    global $show_directory, $show_image, $image_extensions, $ignore_folders, $written_description_file, $save_written_condition;

    // if url contains a directory go there
    if (isset($show_directory) AND $show_directory != '') {
        if (is_dir($show_directory)) {
            chdir($show_directory);
        } else {
            // error directory does not exist!
            header('Location: ' . $_SERVER['SCRIPT_NAME']);
        }
    }
    
    // now get the current directory
    $cwd = getcwd();

    if (file_exists($written_description_file)) {
	$handle = fopen($written_description_file, "r");
	$description = fread($handle, filesize($written_description_file));
	fclose($handle);
    }

    if($save_written_condition){	
	echo '<p  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Saved. </p>';
	echo '<p style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"><a class="index" href="index.php?directory=';
	echo $show_directory;
	echo '&amp;mode=written">Back</a></p>';
    }else {
        draw_form($description);
    }

    // retrieve and show the written description
    // processwritten($files);

    return ob_get_contents();
}


function save_written($str) {
    global $show_directory, $written_description_file;

    // if url contains a directory go there
    if (isset($show_directory) AND $show_directory != '') {
        if (is_dir($show_directory)) {
            chdir($show_directory);
        }
    }
    
    // now get the current directory
    $cwd = getcwd();

    $handle = fopen($written_description_file, "w");
    if (is_writable($written_description_file)) {
	fwrite($handle, $str);
    }
    fclose($handle);
}

function save_ans($ans, $image_file) {
    global $show_directory, $yes_file;

    // if url contains a directory go there
    if (isset($show_directory) AND $show_directory != '') {
        if (is_dir($show_directory)) {
            chdir($show_directory);
        }
    }
    
    // now get the current directory
    $cwd = getcwd();

    //read existing setting	
    if (file_exists($yes_file) && filesize($yes_file)>0) {
	$handle = fopen($yes_file, "r");
	$yes = fread($handle, filesize($yes_file));
	fclose($handle);
	$yes_array = explode('::',chop($yes));

	// add if yes
	if($ans == "yes" && !in_array($image_file, $yes_array)) 
	    array_push($yes_array, $image_file);

	// delete if no	
	if($ans == "no" && in_array($image_file,$yes_array)){
	   $key = array_search($image_file,$yes_array); 
	    unset($yes_array[$key]);
	}

    	$str = implode('::', $yes_array);

    } else {
	// add if yes
	if($ans == "yes") 
	    $str = $image_file;
	else
	    $str = "";
    }

    $handle = fopen($yes_file, "w");
    if (is_writable($yes_file)) {
	fwrite($handle, $str);
    }
    fclose($handle);
}


function process_newsletter() {
    global $show_directory, $show_image, $image_extensions, $ignore_folders, $written_description_file, $yes_file;

    // if url contains a directory go there
    if (isset($show_directory) AND $show_directory != '') {
        if (is_dir($show_directory)) {
            chdir($show_directory);
        } else {
            // error directory does not exist!
            header('Location: ' . $_SERVER['SCRIPT_NAME']);
        }
    }
    
    // now get the current directory
    $cwd = getcwd();
    
    // open directory
    if ($handle = opendir($cwd)) {
        // convert ignored files to an array
        $bad_dirs = explode(' ', $ignore_folders);

        // convert good extensions to an array
        $good_ext = explode(' ', $image_extensions);
        
        // loop through all files adding files and directories to an array
        while (false !== ($file = readdir($handle))) {
            if (!preg_match("/^\./", $file)) {
                // get this files extension
                $this_ext = explode('.', $file);
                $this_ext = $this_ext[count($this_ext) - 1];
                
                // check each file / directory for inclusion
                if (is_dir($file) AND !in_array($file, $bad_dirs)) {
                    $dirs[$file] = $file;
                } else if (in_array($this_ext, $good_ext)) {
                    $files[] = $file;
                }
            }
        }
        // close directory

        closedir($handle);

    	if (file_exists($written_description_file)) {
	    $handle = fopen($written_description_file, "r");
	    $description = fread($handle, filesize($written_description_file));
	    fclose($handle);
	}

    	if (file_exists($yes_file) && filesize($yes_file) > 0) {
	    $handle = fopen($yes_file, "r");
	    $yes = fread($handle, filesize($yes_file));
	    fclose($handle);
	}

        // if there are no files then look for folders
        // otherwise show the images
        //processfiles_newsletter($files, $dirs, $cwd);
        processfiles_newsletter($files, $description, $yes);
    }

    return ob_get_contents();
}



function draw_form($description){
	global $show_directory;
	list($title, $date, $client, $caregiver, $activity, $desc, $mood, $question) = explode('::', $description);
	echo '<form method="post" name="form1" action="index.php"><table class="typeD"><tr> <td style="text-align:right;"><span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;";> Title: </span></td><td style="text-align:left;"><span><input  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;" type="text" size=39 name="title" value="';
	echo $title;

	echo '"></span></td></tr><tr><td style="text-align:right;"> <span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Date: </spn> </td> <td style="text-align:left;"> <span><input  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;" type="text" size=39 name="date" value="';
	echo $date;

	echo '"></span></td></tr><tr><td style="text-align:right;"> <span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Client: </span> </td> <td style="text-align:left;"> <span><input  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;" type="text" size=39 name="client" value="';
	echo $client;

	echo '"></span></td></tr><tr><td style="text-align:right;"> <span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Caregiver: </span> </td> <td style="text-align:left;"> <span><input  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;" type="text" size=39 name="caregiver" value="';
	echo $caregiver;

	echo '"></span></td></tr><tr><td style="text-align:right;"><span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Activity: </span></td><td style="text-align:left;"><span><textarea  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;" name="activity" cols=58 rows=2>';

	echo $activity;

	echo '</textarea></span></td></tr><tr><td style="text-align:right;"><span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Description: </span></td> <td style="text-align:left;"><span><textarea  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;" name="desc" cols=58 rows=2>';

	echo $desc;

	echo '</textarea></span></td></tr><tr><td style="text-align:right;"> <span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Client\'s Mood: </span></td> <td style="text-align:left;"> <span><textarea  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;" name="mood" cols=58 rows=2>';

	echo $mood;

	echo '</textarea></span></td></tr><tr><td style="text-align:right;"> <span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"> Question for Client: </span></td> <td style="text-align:left;"> <span><textarea  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;" name="question" cols=58 rows=1>';

	echo $question;

	echo '</textarea></span></td></tr><tr><td></td><td style="text-align:right;"><span><input type="hidden" name="mode" value="written"/><input type="hidden" name="directory" value="';
	echo $show_directory;
	echo '"/><input type="submit" name="submit" value="Submit" style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"></span></td></tr></table></form>';
}


function processfolders($dirs) {
    global $new_days, $show_directory, $upload_tmp, $upload_fname;

    // if directories exist sort and display them
    if (is_array($dirs)) {                                     
        // sort the directories
        natcasesort($dirs);
        $dirs = array_values($dirs);

        // output the directory listing    
        echo '<div id="content">';    
        echo '<div id="directories">';        
        echo '<ul>';
        for($i=0;$i<count($dirs);$i++) {
            echo '<li>';
            echo '<a href="' . $_SERVER['SCRIPT_NAME'] . '?directory=' . $dirs[$i] . '"';
            if (($i+1) < 10) {
                echo ' title="' . formatname($dirs[$i]) . ' (Alt/Ctrl ' . ($i+1) . ')" accesskey="' . ($i+1) . '" class=index';
            } else {
                echo ' title="' . formatname($dirs[$i]) . '" class=index';
            }
             echo '>';
             //echo formatname($dirs[$i]);
             echo $dirs[$i];
             echo ' (' . countfiles($dirs[$i]) . ')';
             echo '</a>';
             if ($modified = filectime($dirs[$i]) AND $new_days > 0) {
                 $modified = time() - $modified;
                $modified = $modified / 86400;
                
                if ($modified <= $new_days) {
                    echo ' - New!';
                }
             }
             echo '</li>';
        }
        echo '</ul>';        
        echo '</div>';

	echo '<form action="index.php" method="POST">';
	echo '<p style="font-size:10px;font-family:Verdana,Helvetica,Ariel;"><input type="hidden" name="mode" value="photos"/><input  style="font-size:10px;font-family:Verdana,Helvetica,Ariel;" type="text" size="40" name="newalbum" value=""/>';
	echo '<input style="font-size:10px;font-family:Verdana,Helvetica,Ariel;" type="submit" value="Create"></p>';
	echo '</form>';


        echo '</div>';



    } else {
        $path = dirname($_SERVER['PATH_TRANSLATED']) . '/';
        
//        echo '<div id="content">';    
//        echo 'There are no photos for you to browse.';
//        echo '<br />';
//        echo 'To make an album create a directory of images in:';
//        echo '<br />';
//        echo '<tt>' . $path . '</tt>';
//        echo '</div>';

	echo '<form enctype="multipart/form-data" action="index.php" method="POST">';
	echo '<p style="font-size:10px;font-family:Verdana,Helvetica,Ariel;"><input type="hidden" name="mode" value="photos"/>';
	echo '<input type="hidden" name="directory" value="';
	echo $show_directory;
	echo '"/>';
	echo '<input type="hidden" name="MAX_FILE_SIZE" value="2000000"/><input  style="font-size:10px;font-family:Verdana,Helvetica,Ariel;" name="userfile" type = "file"><input  style="font-size:10px;font-family:Verdana,Helvetica,Ariel;" type="submit" value="upload">(jpg, gif; less than 2MB)</p>';
	echo '</form>';

    }
}



function processfiles($files) {
    global $show_directory, $show_image, $image_extensions;
    

    if (is_array($files)) {
        // sort the files
        natcasesort($files);
        $files = array_values($files);
        
        // url of image
        // if none fix link color issue and redirect to image 0 (work around)
        if (isset($show_image) AND is_file($files[$show_image])) {
            $image = $files[$show_image];
        } else {
	    $image = null;
        }
        
        
        // next and previous links for the image
        echo '<div id="content">';
	if ($image != null ) {        
            echo '<div id="text">';
	    if ( $show_image > 0 ) {
		echo '<a href="' . $_SERVER['SCRIPT_NAME'] . '?directory=' . $show_directory . '&amp;image=' . ($show_image - 1) . '" title="' . formatname($files[$show_image - 1]) . '">&laquo; prev</a>';
	    } else {
		echo '&laquo; prev';
	    }
	    echo ' | ';
	    if ($show_image < (count($files) - 1)) {
		echo '<a href="' . $_SERVER['SCRIPT_NAME'] . '?directory=' . $show_directory . '&amp;image=' . ($show_image + 1) . '" title="' . formatname($files[$show_image + 1]) . '">next &raquo;</a>';
	    } else {
		echo 'next &raquo;';
	    }
            echo '</div>';        
	    // image
	    if (file_exists($image)) {
		$image_info = getimagesize($image);
		$image_width = number_format($image_info[0]);
		$image_height = number_format($image_info[1]);
		echo '<div id="photo">';
                echo '<a href="' . $_SERVER['SCRIPT_NAME'] . 
			'?directory=' . $show_directory . '"';
               	echo ' title="' . formatname($dirs[$i]) . 
			'" class=index>';
		echo '<img src="' . $show_directory . '/' . $image . '" width=640 height=480 />';
		echo '</a></div>';
	    }
	    // look for a text file with the picture description
	    $desc_file = explode('.', $image);
	    array_pop($desc_file);
	    $desc_file = implode('.',$desc_file);
	    $desc_file .= '.txt';
	    if (file_exists($desc_file)) {
		$handle = fopen($desc_file, "r");
		$description = fread($handle, filesize($desc_file));
		fclose($handle);

		echo '<div id="description">';
		echo $description;
		echo '</div>';
	    }
	} else {
		//image overview

		echo '<table style="border:0px;text-align:center;">';
		for($i=0;$i<=count($files) - 1;$i++){
		        if (($i) % 4 == 0) echo '<tr>';
			echo '<td style="padding:5px;">';
	                echo '<a href="' . $_SERVER['SCRIPT_NAME'] . 
				'?directory=' . $show_directory . 
				'&amp;image=' . $i . '"';
                	echo ' title="' . formatname($dirs[$i]) . 
				'" class=index>';
			echo '<img src ="' . $show_directory . '/' . 
				$files[$i] . '" width=160 height = 120 />';
			echo '</a>';
			echo '</td>';
		        if (($i) % 4 == 3) echo '</tr>';
		}
		echo '</table>';

		echo '<form enctype="multipart/form-data" action="index.php" method="POST">';
		echo '<p style="font-size:10px;font-family:Verdana,Helvetica,Ariel;"><input type="hidden" name="mode" value="photos"/>';
		echo '<input type="hidden" name="directory" value="';
		echo $show_directory;
		echo '"/>';
		echo '<input type="hidden" name="MAX_FILE_SIZE" value="2000000"/><input  style="font-size:10px;font-family:Verdana,Helvetica,Ariel;" name="userfile" type = "file"><input  style="font-size:10px;font-family:Verdana,Helvetica,Ariel;" type="submit" value="upload">(jpg, gif; less than 2MB)</p>';
		echo '</form>';

	}
        echo '</div>';
        
        return true;
    }
}


function processfiles_newsletter($files, $description, $yes) {
    global $show_directory, $show_image, $image_extensions, $show_print, $show_ans, $yes_file;
    
    list($title, $date, $client, $caregiver, $activity, $desc, $mood, $question) 
		= explode('::', $description);
    $yes_array = explode('::', chop($yes));

    if (is_array($files)) {
        // sort the files
        natcasesort($files);
        $files = array_values($files);
        
        // url of image
        // if none fix link color issue and redirect to image 0 (work around)
        if (isset($show_image) AND is_file($files[$show_image])) {
            $image = $files[$show_image];
        } else {
	    $image = null;
        }

        if ($show_ans == "yes" || $show_ans == "no"){
	    save_ans($show_ans, $files[$show_image - 1]);
        }
        
        // next and previous links for the image
        echo '<div id="content">';
	if ($image != null ) {        
           echo '<div id="text">';
           echo '<form method="POST" name="form2" action="index.php">';
	    echo '<span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;border:1px gray dotted;padding:1px 3px 1px;">';
	    echo $question;
	    echo '</span>&nbsp;&nbsp;';
	    echo '<span style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"><input type="radio" name="ans" value="yes" />Yes</span>';
	    echo '<span  style="font-size:16px;font-family:Verdana,Helvetica,Ariel;"><input type="radio" name="ans" value="no" checked="checked" />No</span>&nbsp;&nbsp;';
	    echo '<input type="hidden" name="image" value="';
	    echo $show_image + 1;
	    echo '"/>';
	    echo '<input type="hidden" name="mode" value="newsletter"/><input type="hidden" name="directory" value="';
	    echo $show_directory;
	    echo '"/><input type="submit" name="submit" value="Answer" style="font-size:16px;font-family:Verdana,Helvetica,Ariel;">';
	    echo '</form>';
	    echo '</div>';
	    // image
	    if (file_exists($image)) {
		$image_info = getimagesize($image);
		$image_width = number_format($image_info[0]);
		$image_height = number_format($image_info[1]);
		echo '<div id="photo">';
		echo '<img src="' . $show_directory . '/' . $image . '" width=576 height=432 />';
		echo '</div>';
	    }
	    // look for a text file with the picture description
	    $desc_file = explode('.', $image);
	    array_pop($desc_file);
	    $desc_file = implode('.',$desc_file);
	    $desc_file .= '.txt';
	    if (file_exists($desc_file)) {
		$handle = fopen($desc_file, "r");
		$description = fread($handle, filesize($desc_file));
		fclose($handle);

		echo '<div id="description">';
		echo $description;
		echo '</div>';
	    }
	} else {
		//Show Newsletter
		echo '<table style="margin:0px;padding:0px;border:0px;border-collapse:collapse;text-align:left"><tr><td style="border:1px black dotted;padding:5px;"><img src="';

		//Hack  -- just use the first picture 
		//echo $show_directory . '/' . $files[0];
    		//Random image from "yes" ones
    		if (file_exists($yes_file) && filesize($yes_file)>0) {
			$handle = fopen($yes_file, "r");
			$yes = fread($handle, filesize($yes_file));
			fclose($handle);
    		}
    		$yes_array = explode('::',chop($yes));
		echo $show_directory . '/';
		echo $yes_array[array_rand($yes_array)];

		echo '" width=240 height=180></td><td  style="margin:0px;padding:5px 50px 5px;border:1px black dotted;" width=640><h1 style="font-family:Verdana,Helvetica,Ariel;color:black;">';

		echo $title;

		echo '</h1><h2 style="font-family:Verdana,Helvetica,Ariel;color:black;"> By: ';

		echo $caregiver;

		echo '</h2></td></tr><tr><td style="vertical-align:top;padding:5px 50px 5px;border:1px black dotted">';
		echo '<p style="font-family:Verdana,Helvetica,Ariel;color:black;"> Client Name: ';	
		echo $client;
		echo '<p style="font-family:Verdana,Helvetica,Ariel;color:black;"> Caregiver Name: ';	
		echo $caregiver;
		echo '</p><p style="font-family:Verdana,Helvetica,Ariel;color:black;">Activity: ';
		echo $activity;
		echo '</p><br><p style="font-family:Verdana,Helvetica,Ariel;color:black;">';
		if ($show_print != "y"){
			echo '<span style="border:1px black dotted;font-size:9px;padding:3px;">';
			echo '<a href="index.php?mode=newsletter&directory=';
			echo $show_directory;
			echo '&print=y" class="index">';
			echo 'Printer Friendly Version';
			echo '</a>';
			echo '</span>';
			echo '<br><br>';
			echo '<span style="border:1px black dotted;font-size:9px;padding:3px;">';
			echo '<a href="index.php?mode=newsletter&directory=';
			echo $show_directory;
			echo '&image=0" class="index">';
			echo 'Client Feedback';
			echo '</a>';
			echo '</span>';
		} else {
			echo '<span style="border:1px black dotted;font-size:9px;padding:3px;">';
			echo '<a href="index.php?mode=newsletter&directory=';
			echo $show_directory;
			echo '" class="index">';
			echo 'Normal Version';
			echo '</a>';
			echo '</span>';
		}

		echo '</span></p></td>';
		echo '<td style="padding:10px 20px 10px;border:1px black dotted"><h2 style="font-family:Verdana,Helvetica,Ariel;color:black;"><span style="border-bottom:1px solid black;">';
		echo 'What happened</span></h2><h3 style="font-family:Verdana,Helvetica,Ariel;color:black;">';

 		echo $desc;
 		echo '</h3><h3 style="font-family:Verdana,Helvetica,Ariel;color:black;">';
 		echo $mood;
		echo '</h3>';
             if(count($yes_array)>0 && strlen($yes) >0){
		echo '<br><table style="border:1px dotted gray;padding:12px;';
		if ($show_print != "y") echo 'background:#FFFF66;';
		echo '"><tr><td><p><h3  style="font-family:Verdana,Helvetica,Ariel;color:black;"><span style="border-bottom:1px black dotted;">';
		echo $question;
		echo '> Yes </span></h3><p>';
		for($i=0;$i<=count($files) - 1;$i++){
 		    if (in_array($files[$i],$yes_array)){
			echo '<p><img src ="' . $show_directory . '/' . 
				$files[$i] . '" width=352 height = 264 />';
			echo '</p>';
                  }
		}
		echo '</td></tr></table>';
            }
            if(count($files) != count($yes_array) || strlen($yes)==0){
		echo '<br><table style="border:1px dotted gray;padding:12px;';
		if ($show_print != "y") echo 'background:#AAAAAA;';
		echo '"><tr><td><p><h3  style="font-family:Verdana,Helvetica,Ariel;color:black;"><span style="border-bottom:1px black dotted;">';
		echo $question;
		echo '> No </span></h3><p>';

		for($i=0;$i<=count($files) - 1;$i++){
 		    if (!in_array($files[$i],$yes_array)){
			echo '<p><img src ="' . $show_directory . '/' . 
				$files[$i] . '" width=352 height = 264 />';
			echo '</p>';
                  }
		}
		echo '</td></tr></table>';
            }
	}
        echo '</div>';
        
        return true;
    }
}


function countfiles($dir) {
    global $image_extensions;
    
    if ($handle = opendir($dir)) {    
        // convert good extensions to an array
        $good_ext = explode(' ', $image_extensions);
        
        // loop through all files adding files and directories to an array
        while (false !== ($file = readdir($handle))) {
        
            if (!preg_match("/^\./", $file)) {
                // get this files extension
                $this_ext = explode('.', $file);
                $this_ext = $this_ext[count($this_ext) - 1];

                // find all the files
                if (in_array($this_ext, $good_ext)) {
                    $files[] = $file;
                }
            }
        }
    
        // close directory
        closedir($handle);

        return count($files);
    } else {
        return false;    
    }
}


function formatname($string) {
    global $image_extensions;
    
    $string = ereg_replace("(-+|_+|r+|t+| +)", ' ', $string);
    
    $image_extension = explode(' ', $image_extensions);
    for($i=0;$i<count($image_extension);$i++) {
        $string = str_replace('.' . $image_extension[$i],'',$string);
    }
    
    $string = ucwords($string);
    return $string;
}


function process_command($command){
    global $show_directory, $show_image, $image_extensions, $ignore_folders, $upload_tmp, $upload_fname, $show_delete, $show_newalbum, $written_description_file;

    // if url contains a directory go there
    if (isset($show_directory) AND $show_directory != '') {
        if (is_dir($show_directory)) {
            chdir($show_directory);
        } else {
            // error directory does not exist!
            header('Location: ' . $_SERVER['SCRIPT_NAME']);
        }
    }
    
    // now get the current directory
    $cwd = getcwd();

    // convert ignored files to an array
    $bad_dirs = explode(' ', $ignore_folders);

    // convert good extensions to an array
    $good_ext = explode(' ', $image_extensions);

    // open directory
    if ($handle = opendir($cwd)) {
        // loop through all files adding files and directories to an array
        while (false !== ($file = readdir($handle))) {
            if (!preg_match("/^\./", $file)) {
                // get this files extension
                $this_ext = explode('.', $file);
                $this_ext = $this_ext[count($this_ext) - 1];
                
                // check each file / directory for inclusion
                if (is_dir($file) AND !in_array($file, $bad_dirs)) {
                    $dirs[$file] = $file;
                } else if (in_array($this_ext, $good_ext)) {
                    $files[] = $file;
                }
            }
        }
        closedir($handle);
    }

    if (file_exists($written_description_file)) {
        $handle = fopen($written_description_file, "r");
        $description = fread($handle, filesize($written_description_file));
        fclose($handle);
    }

    echo '';
    if ($command == "listAlbums")
        process_list_albums($dirs);
    else if ($command == "getClient")
        process_get_client($description);
    else if ($command == "getQuestion")
        process_get_question($description);
    else if ($command == "countPhotos")
        process_count_photos($files);

    return ob_get_contents();

}

function process_list_albums($dirs){
    // if directories exist sort and display them
    if (is_array($dirs)) {                                     
        // sort the directories
        natcasesort($dirs);
        $dirs = array_values($dirs);

        // output the directory listing    
        for($i=0;$i<count($dirs);$i++) {
             echo $dirs[$i];
             echo '<br>';
        }
    }
}

function process_get_client($description){
    list($title, $date, $client, $caregiver, $activity, $desc, $mood, $question) = explode('::', $description);
    echo $client;	
    echo '<br>';
}
function process_get_question($description){
    list($title, $date, $client, $caregiver, $activity, $desc, $mood, $question) = explode('::', $description);
    echo $question;	
    echo '<br>';
}
function process_count_photos($files){
    echo count($files);
    echo '<br>';
}

// generate the photo html
ob_start();
if($show_command == null ){
    if($show_mode == 'photos'){
	    $html_photos = process_photos();
    } else if ($show_mode == 'written') {
    // define the written html
	    $html_written= process_written();
    } else if ($show_mode == 'newsletter') {
	    // define the newsletter html
	    $html_newsletter = process_newsletter();
    } else {
	    $html_photos = process_photos();
    }
} else {
	$html_command = process_command($show_command);
}
ob_end_clean();

if($show_command == null ){
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>AfFFECT IVE (interactive visual explorer) <?php if (strlen($show_directory) > 0) { echo ' : ' . formatname($show_directory); } ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" type="text/css" media="screen" href="<?php echo $style_sheet; ?>" />
</head>
<body style="margin:0px">
<!-- <?php echo $show_newalbum; ?> -->
<?php if($show_print != "y") { ?>
<table style="margin:0px;padding:0px;border:0px;border-collapse:collapse;">
<tr>
<td style="background:url(includes/upper-frame.jpg);height:64px;">
</td>
</tr>

<tr>
<td>

<table style="border:0px;width:100%;text-align:left;vertical-aligh:top;">
<tr>
<td>
<a href="index.php?mode=photos" class=index><img align=texttop border=0px src="includes/album.jpg"></a>
</td>
<td width=300>
&nbsp;&nbsp;&nbsp;&nbsp;
<span style="font-family:Verdana,Helvetica,Ariel;font-weight:bold;font-size:<?php if($show_mode != 'written' && $show_mode !='newsletter') echo "30px;"; else echo "18px;"; ?> ">
<img src="includes/numOne.jpg" 
height=<?php if($show_mode != 'written' && $show_mode !='newsletter') echo "40"; else echo "25"; ?> 
width=<?php if($show_mode != 'written' &&  $show_mode !='newsletter') echo "40"; else echo "25"; ?> align=texttop>
<a href="index.php?mode=photos&directory=<?php echo $show_directory ?>" class="index">Photos</a></span>
</td>
<td width=300>

&nbsp;&nbsp;&nbsp;&nbsp;
<span style="font-family:Verdana,Helvetica,Ariel;font-weight:bold;font-size:<?php if($show_mode == 'written') echo "30px;"; else echo "18px;"; ?>">
<img src="includes/numTwo.jpg" 
height=<?php if($show_mode == 'written') echo "40"; else echo "25"; ?>  
width=<?php if($show_mode == 'written' ) echo "40"; else echo "25"; ?>  
align=texttop>
<?php if($show_directory != null) {?>
<a href="index.php?mode=written&directory=<?php echo $show_directory ?>" class="index">
<?php }?>
Written
<?php if($show_directory != null) {?>
</a>
<?php } ?>
</span>
</td>
<td width=300>

&nbsp;&nbsp;&nbsp;&nbsp;
<span style="font-family:Verdana,Helvetica,Ariel;font-weight:bold;font-size:<?php if($show_mode == 'newsletter') echo "30px;"; else echo "18px;"; ?>">
<img src="includes/numThree.jpg" 
height=<?php if($show_mode == 'newsletter') echo "40"; else echo "25"; ?>   
width=<?php if($show_mode == 'newsletter') echo "40"; else echo "25"; ?>   
align=texttop>
<?php if($show_directory != null) {?>
<a href="index.php?mode=newsletter&directory=<?php echo $show_directory ?>" class="index">
<?php } ?>
Newsletter
<?php if($show_directory != null) {?>
</a>
<?php } ?>
</span>
</td>
</tr>
</table>

</td>
</tr>
<tr style="margin-top:10px;">
<td style="background-color:white;padding-left:60px;padding-right:60px;">
<table style="margin-top:10px;width:750px;border:0px;" align="center">
<tr>
<td style="background:url(includes/yellow_box.jpg) no-repeat;padding:20px;width=750px;height:500px;text-align:center;vertical-align:top;">
<?php 
}
?>
<?php 
if ($show_mode == 'photos'){
	echo $html_photos; 
} else if ($show_mode == 'written') {
	echo $html_written;
} else if ($show_mode == 'newsletter') {
	echo $html_newsletter;
} else {
	echo $html_photos; 
}
if ($save_written_condition){

//	$save_str = 'Shin\'ichi\'s Day Out::May 25, 3005::Going to the park.::Shin\'ichi took bus to park. Sat by creek.::Happy most of the time. Sad to come home. ';

	$save_str = $show_title . '::' . $show_date . '::' . $show_client . '::' . $show_caregiver . '::' . $show_activity . '::' . $show_desc . '::' . $show_mood . '::' . $show_question;
	save_written(stripcslashes($save_str));
//	header('Location: ' . $_SERVER['SCRIPT_NAME'] . '?directory=' . $show_directory . '&amp;mode=' . $show_mode);
}
?>

<?php if($show_print != "y") { ?>
</td>
</tr>
</table>

</td>
</tr>

<?php if($show_image != null && $show_image != '' && $show_mode != 'newsletter'){ ?>
<tr>
<td style="text-align:right;padding-left:60px;padding-right:60px;">
<a href="index.php?mode=photos&directory=<?php echo $show_directory; ?>&delete=<?php echo $show_image; ?>">
<img style="border:0px" src="includes/trash.jpg"> 
</a>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
</td>
</tr>
<?php } ?>

</table>
<?php 
}
?>

</body>
</html>
<?php 
} 
echo $html_command;
?>
